GNU bug report logs - #36777
Guix Inferiors: Curious incorrect derivation output bug

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Severity: important; Reported by: Carl Dong <contact@HIDDEN>; Done: Ludovic Courtès <ludo@HIDDEN>; Maintainer for guix is bug-guix@HIDDEN.

Message received at 36777-done <at> debbugs.gnu.org:


Received: (at 36777-done) by debbugs.gnu.org; 16 Aug 2019 21:03:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Aug 16 17:03:32 2019
Received: from localhost ([127.0.0.1]:55022 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hyjNk-0004qZ-KJ
	for submit <at> debbugs.gnu.org; Fri, 16 Aug 2019 17:03:32 -0400
Received: from eggs.gnu.org ([209.51.188.92]:46153)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1hyjNi-0004qL-T3
 for 36777-done <at> debbugs.gnu.org; Fri, 16 Aug 2019 17:03:31 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59241)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1hyjNd-0003F3-DW; Fri, 16 Aug 2019 17:03:25 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=50860 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1hyjNc-0003WD-Gx; Fri, 16 Aug 2019 17:03:25 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Carl Dong <contact@HIDDEN>
Subject: Re: bug#36777: Guix Inferiors: Curious incorrect derivation output bug
References: <TifHDa-L4paOnZQruSSv3YhpIdqMvwlk7pwnElq9azsMZwEdFv3-0usXgSQkV4nIOuKoJzv-BwIurwdecWYX-BTGUn2xZXAqQzefQp85W7M=@carldong.me>
 <875znps08a.fsf@HIDDEN>
 <1WSz93jYl9XxYywM_b-gQYV4SiIG9VyTXLYpj4bueFcBZByRMIdXQNnVY4YDnbH_hPe4y_ZDjl7lIgyvynH8J85NtO93namyeEVMU7Lj9WY=@carldong.me>
 <87wog3i2sj.fsf@HIDDEN> <87r26bi1x2.fsf@HIDDEN>
 <rvQNShnNXKeE-TRrrP9SzUqXX4dJEB481poZeW9Rh_RZ7tgj7BRuBFnV049S2IfmM6v32jY1T8WM_zn5ZDX-2Kyfw16jm4wSaRshHnntHJQ=@carldong.me>
Date: Fri, 16 Aug 2019 23:03:23 +0200
In-Reply-To: <rvQNShnNXKeE-TRrrP9SzUqXX4dJEB481poZeW9Rh_RZ7tgj7BRuBFnV049S2IfmM6v32jY1T8WM_zn5ZDX-2Kyfw16jm4wSaRshHnntHJQ=@carldong.me>
 (Carl Dong's message of "Tue, 30 Jul 2019 18:36:01 +0000")
Message-ID: <87h86gg6w4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36777-done
Cc: "36777 <at> debbugs.gnu.org" <36777-done <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Carl,

Carl Dong <contact@HIDDEN> skribis:

> Yes! The patch actually fixed the problem when applied on top of 5cf4b26d=
52bcea382d98fb4becce89be9ee37b55!

[...]

> Not sure what the next steps are for this, but I'd very much like to unde=
rstand where this went wrong. Perhaps we could write tests for this so it d=
oesn't happen in the future for releases.

Yup, I understood when this could happen (if multiple inputs of a
derivation are =E2=80=9Cfixed-output=E2=80=9D derivations leading to the sa=
me output),
wrote a test for that, and came up with a simpler fix in commit
268896444bed7b958add74b2e1e86ff802c5f5cb.

Let me know if anything is amiss!

Thanks for testing the patch,
Ludo=E2=80=99.




Notification sent to Carl Dong <contact@HIDDEN>:
bug acknowledged by developer. Full text available.
Reply sent to Ludovic Courtès <ludo@HIDDEN>:
You have taken responsibility. Full text available.

Message received at 36777 <at> debbugs.gnu.org:


Received: (at 36777) by debbugs.gnu.org; 30 Jul 2019 18:36:20 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jul 30 14:36:19 2019
Received: from localhost ([127.0.0.1]:51162 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hsWyx-0007VZ-Eh
	for submit <at> debbugs.gnu.org; Tue, 30 Jul 2019 14:36:19 -0400
Received: from mail1.protonmail.ch ([185.70.40.18]:42792)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contact@HIDDEN>) id 1hsWyu-0007VJ-RH
 for 36777 <at> debbugs.gnu.org; Tue, 30 Jul 2019 14:36:17 -0400
Date: Tue, 30 Jul 2019 18:36:01 +0000
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=carldong.me;
 s=protonmail; t=1564511768;
 bh=GQppfG6ovjgoLNzc6waW9YOc3nYsjNFb3efajgkHt8A=;
 h=Date:To:From:Cc:Reply-To:Subject:In-Reply-To:References:
 Feedback-ID:From;
 b=HnaWaQ/OGOexymM4tmbQfFp6GzpHr6cz0dhZpuhchBHWAOc8ssBEmfe/RuU/7X6LT
 MtWJIf8wpZSLvEWcddJuFsbid6mPgvsdTeTuZ/F0441BfHvW9AZn5F1E0hX49Da9Hm
 WE2I3Tmksc7SsZZmQsxvFoFgyVawrfoTI3d9I+yo=
To: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
From: Carl Dong <contact@HIDDEN>
Subject: Re: bug#36777: Guix Inferiors: Curious incorrect derivation output bug
Message-ID: <rvQNShnNXKeE-TRrrP9SzUqXX4dJEB481poZeW9Rh_RZ7tgj7BRuBFnV049S2IfmM6v32jY1T8WM_zn5ZDX-2Kyfw16jm4wSaRshHnntHJQ=@carldong.me>
In-Reply-To: <87r26bi1x2.fsf@HIDDEN>
References: <TifHDa-L4paOnZQruSSv3YhpIdqMvwlk7pwnElq9azsMZwEdFv3-0usXgSQkV4nIOuKoJzv-BwIurwdecWYX-BTGUn2xZXAqQzefQp85W7M=@carldong.me>
 <875znps08a.fsf@HIDDEN>
 <1WSz93jYl9XxYywM_b-gQYV4SiIG9VyTXLYpj4bueFcBZByRMIdXQNnVY4YDnbH_hPe4y_ZDjl7lIgyvynH8J85NtO93namyeEVMU7Lj9WY=@carldong.me>
 <87wog3i2sj.fsf@HIDDEN> <87r26bi1x2.fsf@HIDDEN>
Feedback-ID: a8j8tDUaJ4AYuDVBywMTwsJebN4w8TVXadJLsJb8td3t3dZi9RdXFlPaQvoFKnI9KgXySsPXcRkajVyY0cGTcA==:Ext:ProtonMail
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Status: No, score=-1.2 required=7.0 tests=ALL_TRUSTED,DKIM_SIGNED,
 DKIM_VALID,DKIM_VALID_AU,DKIM_VALID_EF autolearn=ham
 autolearn_force=no version=3.4.2
X-Spam-Checker-Version: SpamAssassin 3.4.2 (2018-09-13) on mail.protonmail.ch
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 36777
Cc: "36777\\@debbugs.gnu.org" <36777 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Carl Dong <contact@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

All,

Yes! The patch actually fixed the problem when applied on top of 5cf4b26d52=
bcea382d98fb4becce89be9ee37b55! I was also able to come up with a minimal r=
eproducing manifest:

```
(use-modules (guix inferior) (guix channels)
             (srfi srfi-1))   ;for 'first'

(define channels
  (list (channel
         (name 'guix)
         (url "https://git.savannah.gnu.org/git/guix.git")
         (commit
          "6869b6635afd93872b8f0d9f2db0db4c0d765a86"))))

(define inferior
  ;; An inferior representing the above revision.
  (inferior-for-channels channels))

(packages->manifest
  (map (lambda (x)
         (first (lookup-inferior-packages inferior x)))
       '("gzip")))
```

It seems that the `gzip` package is what's causing this.

Not sure what the next steps are for this, but I'd very much like to unders=
tand where this went wrong. Perhaps we could write tests for this so it doe=
sn't happen in the future for releases.

Cheers,
Carl Dong
contact@HIDDEN
"I fight for the users"




Information forwarded to bug-guix@HIDDEN:
bug#36777; Package guix. Full text available.
Severity set to 'important' from 'normal' Request was from Ludovic Courtès <ludo@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 36777 <at> debbugs.gnu.org:


Received: (at 36777) by debbugs.gnu.org; 27 Jul 2019 21:49:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 27 17:49:06 2019
Received: from localhost ([127.0.0.1]:45520 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hrUYs-0008Gc-KT
	for submit <at> debbugs.gnu.org; Sat, 27 Jul 2019 17:49:06 -0400
Received: from eggs.gnu.org ([209.51.188.92]:44712)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1hrUYr-0008G5-FJ
 for 36777 <at> debbugs.gnu.org; Sat, 27 Jul 2019 17:49:05 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45949)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1hrUYm-0007eZ-4B; Sat, 27 Jul 2019 17:49:00 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=35296 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1hrUYl-0005it-L0; Sat, 27 Jul 2019 17:48:59 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Carl Dong <contact@HIDDEN>
Subject: Re: bug#36777: Guix Inferiors: Curious incorrect derivation output bug
References: <TifHDa-L4paOnZQruSSv3YhpIdqMvwlk7pwnElq9azsMZwEdFv3-0usXgSQkV4nIOuKoJzv-BwIurwdecWYX-BTGUn2xZXAqQzefQp85W7M=@carldong.me>
 <875znps08a.fsf@HIDDEN>
 <1WSz93jYl9XxYywM_b-gQYV4SiIG9VyTXLYpj4bueFcBZByRMIdXQNnVY4YDnbH_hPe4y_ZDjl7lIgyvynH8J85NtO93namyeEVMU7Lj9WY=@carldong.me>
 <87wog3i2sj.fsf@HIDDEN>
Date: Sat, 27 Jul 2019 23:48:57 +0200
In-Reply-To: <87wog3i2sj.fsf@HIDDEN> ("Ludovic
 \=\?utf-8\?Q\?Court\=C3\=A8s\=22'\?\=
 \=\?utf-8\?Q\?s\?\= message of "Sat, 27 Jul 2019 23:30:04 +0200")
Message-ID: <87r26bi1x2.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36777
Cc: "36777 <at> debbugs.gnu.org" <36777 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Ludovic Court=C3=A8s <ludo@HIDDEN> skribis:

> For future reference, the bisect output is:
>
>   # first bad commit: [5cf4b26d52bcea382d98fb4becce89be9ee37b55] derivati=
ons: <derivation-input> now aggregates a <derivation>.

Does the patch below have any effect?

My understanding is that it shouldn=E2=80=99t have any effect (because inpu=
ts
have already been coalesced at that point), but that=E2=80=99s one place wh=
ere
5cf4b26d52bcea382d98fb4becce89be9ee37b55 introduced a difference.

Thanks in advance,
Ludo=E2=80=99.


--=-=-=
Content-Type: text/x-patch
Content-Disposition: inline

diff --git a/guix/derivations.scm b/guix/derivations.scm
index 92d50503ce..eb94fea55e 100644
--- a/guix/derivations.scm
+++ b/guix/derivations.scm
@@ -239,12 +239,17 @@ the store."
   "Return a list of inputs, such that when INPUTS contains the same DRV twice,
 they are coalesced, with their sub-derivations merged.  This is needed because
 Nix itself keeps only one of them."
+  (define (derivation-file-name* obj)
+    (if (derivation? obj)
+        (derivation-file-name obj)
+        obj))
+
   (fold (lambda (input result)
           (match input
-            (($ <derivation-input> (= derivation-file-name path) sub-drvs)
+            (($ <derivation-input> (= derivation-file-name* path) sub-drvs)
              ;; XXX: quadratic
              (match (find (match-lambda
-                            (($ <derivation-input> (= derivation-file-name p)
+                            (($ <derivation-input> (= derivation-file-name* p)
                                                    s)
                              (string=? p path)))
                           result)
@@ -685,7 +690,7 @@ name of each input with that input's hash."
                              (make-derivation-input hash sub-drvs))))
                         inputs)))
        (make-derivation outputs
-                        (sort inputs
+                        (sort (coalesce-duplicate-inputs inputs)
                               (lambda (drv1 drv2)
                                 (string<? (derivation-input-derivation drv1)
                                           (derivation-input-derivation drv2))))

--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#36777; Package guix. Full text available.

Message received at 36777 <at> debbugs.gnu.org:


Received: (at 36777) by debbugs.gnu.org; 27 Jul 2019 21:30:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Jul 27 17:30:18 2019
Received: from localhost ([127.0.0.1]:45502 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hrUGf-0007nE-VX
	for submit <at> debbugs.gnu.org; Sat, 27 Jul 2019 17:30:18 -0400
Received: from eggs.gnu.org ([209.51.188.92]:40357)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1hrUGb-0007md-Pr
 for 36777 <at> debbugs.gnu.org; Sat, 27 Jul 2019 17:30:14 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:45819)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1hrUGW-0001Dc-Ip; Sat, 27 Jul 2019 17:30:08 -0400
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=35228 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1hrUGU-0002to-Vl; Sat, 27 Jul 2019 17:30:07 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Carl Dong <contact@HIDDEN>
Subject: Re: bug#36777: Guix Inferiors: Curious incorrect derivation output bug
References: <TifHDa-L4paOnZQruSSv3YhpIdqMvwlk7pwnElq9azsMZwEdFv3-0usXgSQkV4nIOuKoJzv-BwIurwdecWYX-BTGUn2xZXAqQzefQp85W7M=@carldong.me>
 <875znps08a.fsf@HIDDEN>
 <1WSz93jYl9XxYywM_b-gQYV4SiIG9VyTXLYpj4bueFcBZByRMIdXQNnVY4YDnbH_hPe4y_ZDjl7lIgyvynH8J85NtO93namyeEVMU7Lj9WY=@carldong.me>
Date: Sat, 27 Jul 2019 23:30:04 +0200
In-Reply-To: <1WSz93jYl9XxYywM_b-gQYV4SiIG9VyTXLYpj4bueFcBZByRMIdXQNnVY4YDnbH_hPe4y_ZDjl7lIgyvynH8J85NtO93namyeEVMU7Lj9WY=@carldong.me>
 (Carl Dong's message of "Fri, 26 Jul 2019 19:58:16 +0000")
Message-ID: <87wog3i2sj.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="=-=-="
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36777
Cc: "36777 <at> debbugs.gnu.org" <36777 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi Carl,

Carl Dong <contact@HIDDEN> skribis:

> I did some more digging, and have included a git-bisect log, the -info-di=
r.drv,
> and -info-dir-builder here:
>
> https://gist.github.com/dongcarl/0a305badf20c9b5cfae738147ca416af

For future reference, the bisect output is:

  # first bad commit: [5cf4b26d52bcea382d98fb4becce89be9ee37b55] derivation=
s: <derivation-input> now aggregates a <derivation>.

and =E2=80=98info-dir.drv=E2=80=99 is attached below.

I looked at the offending commit.  I don=E2=80=99t doubt it has the potenti=
al to
introduce such a bug :-), but so far I haven=E2=80=99t seen anything fishy =
as I
inspected it with a fresh eye.

Could you come up with a reduced reproducer for this?  Ideally a small
manifest, the commit of the Guix you=E2=80=99re using (not just that of the
inferior), maybe a manifest that doesn=E2=80=99t even use inferiors, and so=
 on.

Alternately, since the problem is that the output path of the derivation
is incorrectly computed, you could add =E2=80=98pk=E2=80=99 calls to print =
the value of
=E2=80=98drv-masked=E2=80=99 in (guix derivations) or similar.  That=E2=80=
=99s not going to be
convenient, though.  :-/

Ludo=E2=80=99.

PS: I=E2=80=99ll be away from keyboard so I won=E2=80=99t be able to look i=
nto it until
    some time.


--=-=-=
Content-Type: text/plain
Content-Disposition: attachment; filename=t.drv
Content-Transfer-Encoding: quoted-printable
Content-Description: the derivation

Derive([("out","/gnu/store/q9hkdidycz3wq28xxgjq47bzx5s39k52-info-dir","",""=
)],[("/gnu/store/1lyb9v2fnbflccrawnzjw2n87ycaicia-glibc-cross-riscv64-linux=
-gnu-2.27.drv",["out","static"]),("/gnu/store/3wxvpcvxr5qgs2i1wx0cqyspv3in1=
kws-linux-libre-headers-cross-riscv64-linux-gnu-4.19.59.drv",["out"]),("/gn=
u/store/4d4si2aiviy0ldihj7ymjkxrvx6c7rvq-i686-linux-gnu-toolchain-9.1.0.drv=
",["out"]),("/gnu/store/4imc4bigz499427hqd2yvz38y361vq5k-gcc-cross-arm-linu=
x-gnueabihf-9.1.0.drv",["out"]),("/gnu/store/5i49zz5l4dzh59fi2b8fiq2llw0rkn=
8s-python-3.7.0.drv",["out"]),("/gnu/store/60x9nffmmdahdfmd0argjkfcvkzcm4c3=
-linux-libre-headers-cross-x86_64-linux-gnu-4.19.59.drv",["out"]),("/gnu/st=
ore/7s7lml5cgign328i6nk13fxz0r2vykng-binutils-cross-x86_64-linux-gnu-2.31.1=
.drv",["out"]),("/gnu/store/7zc3ms7wxjg9ypg7r4p23ni18f43m6p1-linux-libre-he=
aders-cross-aarch64-linux-gnu-4.19.59.drv",["out"]),("/gnu/store/82r3931cfj=
m1864mc81wzzlfmb5rlgx1-util-linux-2.32.1.drv",["out"]),("/gnu/store/8wgjmm3=
cks3xaabhm3m7w25i9wwx50z2-sed-4.5.drv",["out"]),("/gnu/store/9dgy50xx4d9f2p=
nh4s0pdla7n7j61mjg-findutils-4.6.0.drv",["out"]),("/gnu/store/arvm0v20n93mr=
a1s2la59by3kbm3cbsd-guile-2.2.4.drv",["out"]),("/gnu/store/c0ngi4rm0avjlp3n=
b8j4yvmdlf598vr2-gzip-1.9.drv",["out"]),("/gnu/store/c0pcf8c405my5g7nsc99gx=
pq66hzynn8-gcc-cross-riscv64-linux-gnu-9.1.0.drv",["out"]),("/gnu/store/c59=
fjany683kns33dhb44hfc598654xh-libtool-2.4.6.drv",["out"]),("/gnu/store/d6in=
hd29h4mp3zfah4dq6mh0hi1bwsd6-gcc-glibc-2.27-toolchain-9.1.0.drv",["out"]),(=
"/gnu/store/dwjr2d9ds00bg8dvmsmljygz6k9y6b5h-tar-1.30.drv",["out"]),("/gnu/=
store/fgv06c04vkf52s8idc5jm6c10nsa2ph1-bash-4.4.23.drv",["out"]),("/gnu/sto=
re/gj3b2r65jfgrz83b6nni44028xciakfy-libfaketime-0.9.7.drv",["out"]),("/gnu/=
store/iddbw29p9fq2ccygwhyvfc5r7yq0qlyr-grep-3.1.drv",["out"]),("/gnu/store/=
iv231dbdxg300rk9lqmgkdm855hdxzgr-binutils-cross-aarch64-linux-gnu-2.31.1.dr=
v",["out"]),("/gnu/store/jdzrl9rrdxvyg7y639igda091w1aja1b-module-import-com=
piled.drv",["out"]),("/gnu/store/k9y9vjpv62nvksm5pgbxfy2ddgkrmwmv-linux-lib=
re-headers-cross-i686-linux-gnu-4.19.59.drv",["out"]),("/gnu/store/kx4f618m=
crmkizp5gxyb00fwn1hp4cbw-gcc-cross-aarch64-linux-gnu-9.1.0.drv",["out"]),("=
/gnu/store/ljjw2dnwpdq73fg3rjh58yw27qalyssc-linux-libre-headers-cross-arm-l=
inux-gnueabihf-4.19.59.drv",["out"]),("/gnu/store/lm5x5sz3s5h4drn0n2l0xrbnq=
r9xyqzd-gcc-cross-x86_64-linux-gnu-9.1.0.drv",["out"]),("/gnu/store/m3fqaak=
2rc24ic0aisbl1fdafy14fb45-gcc-cross-i686-linux-gnu-9.1.0.drv",["out"]),("/g=
nu/store/maiy0a31cqlsls1g139hikwabv7wwvbh-zlib-1.2.11.drv",["out"]),("/gnu/=
store/n05hlghlgw64ljc8hgbimbajnlapssiw-glibc-cross-aarch64-linux-gnu-2.27.d=
rv",["out","static"]),("/gnu/store/n8a9mj131ddip42cmcci3s12a3y01zj3-texinfo=
-6.5.drv",["out"]),("/gnu/store/nas9cw7lk7737ha4icmdw5yhxx4j9453-which-2.21=
.drv",["out"]),("/gnu/store/ngj6zhpajm7693ys419yxmkdpcqwkzg9-tcsh-6.20.00.d=
rv",["out"]),("/gnu/store/nz7vl4xn2s3xwx2f7vlvhl8sp9h4lkgx-glibc-utf8-local=
es-2.28.drv",["out"]),("/gnu/store/nzq7zmb44hn9wzm997pn0cb0aak7nmxq-binutil=
s-cross-arm-linux-gnueabihf-2.31.1.drv",["out"]),("/gnu/store/ph6l1b0ixbvgh=
vs41dpm06wqf4pw5677-glibc-cross-i686-linux-gnu-2.27.drv",["out","static"]),=
("/gnu/store/pjnibkx89y2nq3r9wb6dkscdb9rs915z-pkg-config-0.29.2.drv",["out"=
]),("/gnu/store/pwfrz20z33lhgkvy3y1s9gm2ijwcacrk-coreutils-8.30.drv",["out"=
]),("/gnu/store/q0l8y15xksvrm6fpn6miivk1dy88ka1a-riscv64-linux-gnu-toolchai=
n-9.1.0.drv",["out"]),("/gnu/store/q1v24z3zfnym7fqbbh4z4jcybaaiwzlv-m4-1.4.=
18.drv",["out"]),("/gnu/store/q24ic25gr3azaxlabh9pj842kybs8h4m-file-5.33.dr=
v",["out"]),("/gnu/store/qk22gsq1vrkzhrpmmlr2084f4vvlsyg4-make-4.2.1.drv",[=
"out"]),("/gnu/store/qm501xmx0p6h2qyk2jfg6i35n2g2iblw-autoconf-2.69.drv",["=
out"]),("/gnu/store/qxs84gr9g0vinyq433ym226d54nr668a-diffutils-3.6.drv",["o=
ut"]),("/gnu/store/r3ih0hhv74bp4qkg6zfi6wd4bqzlq7df-perl-5.28.0.drv",["out"=
]),("/gnu/store/rmqarqss73akz9yaad4a02zdvp62ijx2-gzip-1.9.drv",["out"]),("/=
gnu/store/rwz69w3nnbxvzwnkrrhq1q5fqf1d6rm1-glibc-cross-x86_64-linux-gnu-2.2=
7.drv",["out","static"]),("/gnu/store/s5ajxc1mc2j6njkjs2bj6ssfzb43bvan-arm-=
linux-gnueabihf-toolchain-9.1.0.drv",["out"]),("/gnu/store/s66bj62iwlh9fndc=
yv06z997zp6ga7fy-aarch64-linux-gnu-toolchain-9.1.0.drv",["out"]),("/gnu/sto=
re/vi1jc3vkpw13nigqzw7iiqqcq9c1xinz-glibc-cross-arm-linux-gnueabihf-2.27.dr=
v",["out","static"]),("/gnu/store/vxh3p0y6v577gzfp016v1xz5xs5lg47m-x86_64-l=
inux-gnu-toolchain-9.1.0.drv",["out"]),("/gnu/store/w1wcggyikprn54y2c2hf1wk=
9bkn9ryja-automake-1.16.1.drv",["out"]),("/gnu/store/wan77da4mrf8x2fwc0yqnd=
pz6v0fwqja-gawk-4.2.1.drv",["out"]),("/gnu/store/wcnmh5krgmz8a9x59r2gzpd81y=
bn5b7v-xz-5.2.4.drv",["out"]),("/gnu/store/wgfz82qfkh9vgqlpa5icj3bzqclyg8rj=
-bzip2-1.0.6.drv",["out"]),("/gnu/store/x9kynl44rpqxd78vbv8j2z58j1vmar0r-bi=
nutils-cross-i686-linux-gnu-2.31.1.drv",["out"]),("/gnu/store/xk4qgfc77rd4k=
4c863fxsyxkxfi9c0ja-binutils-cross-riscv64-linux-gnu-2.31.1.drv",["out"]),(=
"/gnu/store/yvm7rgcskmgsjx6wnxx2gjp71gz6ghjh-patch-2.7.6.drv",["out"])],["/=
gnu/store/ak3y80w6xjr9fq22bw8d577zkm9qq005-info-dir-builder","/gnu/store/p5=
q59xqmhwg60y2437fnny76nw7l6gbz-module-import"],"x86_64-linux","/gnu/store/r=
658y3cgpnf99nxjxqgjiaizx20ac4k0-guile-2.2.4/bin/guile",["--no-auto-compile"=
,"-L","/gnu/store/p5q59xqmhwg60y2437fnny76nw7l6gbz-module-import","-C","/gn=
u/store/syp239hi3xjgxdm8r4hvhhzh67i5ixgl-module-import-compiled","/gnu/stor=
e/ak3y80w6xjr9fq22bw8d577zkm9qq005-info-dir-builder"],[("allowSubstitutes",=
"0"),("guix properties","((type . profile-hook) (hook . info-dir))"),("out"=
,"/gnu/store/q9hkdidycz3wq28xxgjq47bzx5s39k52-info-dir"),("preferLocalBuild=
","1")])
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#36777; Package guix. Full text available.

Message received at 36777 <at> debbugs.gnu.org:


Received: (at 36777) by debbugs.gnu.org; 26 Jul 2019 19:58:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 26 15:58:28 2019
Received: from localhost ([127.0.0.1]:43396 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hr6MG-0004Jj-4j
	for submit <at> debbugs.gnu.org; Fri, 26 Jul 2019 15:58:28 -0400
Received: from mail-40132.protonmail.ch ([185.70.40.132]:39356)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contact@HIDDEN>) id 1hr6ME-0004JT-6d
 for 36777 <at> debbugs.gnu.org; Fri, 26 Jul 2019 15:58:26 -0400
Date: Fri, 26 Jul 2019 19:58:16 +0000
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=carldong.me;
 s=protonmail; t=1564171098;
 bh=KZEkLCssAQ6QEjwRu03jU0WRB9PO+ET6QN1PuSRnajE=;
 h=Date:To:From:Cc:Reply-To:Subject:In-Reply-To:References:
 Feedback-ID:From;
 b=f8tedcvzm3FS4DhdTdzciWl8h+BuQ29K7YFFD97mM1ObMHbi1A/uCDJ8nSaFCzOjB
 6T6fhRmBujUR33eHcfb1JcqiadgaNt009yoH9xZPaUSbAsI+E/Cve8O4cPpgC2ef4w
 O8jRWu62e1s/Mzn07sIIZiGEoIjGKs75BIEZmy5U=
To: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
From: Carl Dong <contact@HIDDEN>
Subject: Re: bug#36777: Guix Inferiors: Curious incorrect derivation output bug
Message-ID: <1WSz93jYl9XxYywM_b-gQYV4SiIG9VyTXLYpj4bueFcBZByRMIdXQNnVY4YDnbH_hPe4y_ZDjl7lIgyvynH8J85NtO93namyeEVMU7Lj9WY=@carldong.me>
In-Reply-To: <875znps08a.fsf@HIDDEN>
References: <TifHDa-L4paOnZQruSSv3YhpIdqMvwlk7pwnElq9azsMZwEdFv3-0usXgSQkV4nIOuKoJzv-BwIurwdecWYX-BTGUn2xZXAqQzefQp85W7M=@carldong.me>
 <875znps08a.fsf@HIDDEN>
Feedback-ID: a8j8tDUaJ4AYuDVBywMTwsJebN4w8TVXadJLsJb8td3t3dZi9RdXFlPaQvoFKnI9KgXySsPXcRkajVyY0cGTcA==:Ext:ProtonMail
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Status: No, score=-1.2 required=7.0 tests=ALL_TRUSTED,DKIM_SIGNED,
 DKIM_VALID,DKIM_VALID_AU,DKIM_VALID_EF autolearn=ham
 autolearn_force=no version=3.4.2
X-Spam-Checker-Version: SpamAssassin 3.4.2 (2018-09-13) on mail.protonmail.ch
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 36777
Cc: "36777 <at> debbugs.gnu.org" <36777 <at> debbugs.gnu.org>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Carl Dong <contact@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hi all,

I did some more digging, and have included a git-bisect log, the -info-dir.=
drv,
and -info-dir-builder here:

https://gist.github.com/dongcarl/0a305badf20c9b5cfae738147ca416af

Please let me know if I can provide more information.

Cheers,
Carl Dong
contact@HIDDEN
"I fight for the users"

=E2=80=90=E2=80=90=E2=80=90=E2=80=90=E2=80=90=E2=80=90=E2=80=90 Original Me=
ssage =E2=80=90=E2=80=90=E2=80=90=E2=80=90=E2=80=90=E2=80=90=E2=80=90
On Friday, July 26, 2019 7:50 AM, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote=
:

> Hello Carl,
>
> Carl Dong contact@HIDDEN skribis:
>
> > I have my manifest.scm here:
> > https://github.com/dongcarl/bitcoin/blob/2019-06-guix-channels-and-infe=
riors/contrib/guix/manifest.scm,
> > and it references the aforementioned Guix channel.
>
> This one appears to work for me (I interrupted it before it was done
> compiling all the toolchains, though.)
>
> > What I expect to happen is that now when I change my default profile's =
Guix
> > version by 'guix pull'ing, it won't affect the environment that's gener=
ated by
> > the manifest.scm. I've tested this with differing versions of Guix as m=
y default
> > profile, and this seems to work with 7304d5623ab5cc35289cb1535cbd0d8a37=
691fac
> > and 7f1c69f5d32bee6b8b6b902a9ce445e04aa9d07d being my default profile. =
However,
> > I tried an older version b6dc08393e6a8313b88ce422fc3c1e4e9c0efc6f, and =
got the
> > following error:
>
> When I put b6dc08393e6a8313b88ce422fc3c1e4e9c0efc6f in .guix-channel and
> use that as my channel, it also works fine (well, I commented out the
> toolchains as well.)
>
> >     guix environment: error: derivation `/gnu/store/r641vpqc9rfjhljf7rz=
fzwmkmpa642ls-info-dir.drv' has incorrect output `/gnu/store/q9hkdidycz3wq2=
8xxgjq47bzx5s39k52-info-dir', should be `/gnu/store/z5hh2nl0h58b9f6hdxfwm00=
gjyxfcc3n-info-dir'
> >
>
> That definitely looks like a bug.
>
> Could you send the faulty info-dir.drv file?
>
> Thanks,
> Ludo=E2=80=99.






Information forwarded to bug-guix@HIDDEN:
bug#36777; Package guix. Full text available.

Message received at 36777 <at> debbugs.gnu.org:


Received: (at 36777) by debbugs.gnu.org; 26 Jul 2019 07:50:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Jul 26 03:50:56 2019
Received: from localhost ([127.0.0.1]:40767 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hqv0C-0000JL-HU
	for submit <at> debbugs.gnu.org; Fri, 26 Jul 2019 03:50:56 -0400
Received: from eggs.gnu.org ([209.51.188.92]:47394)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1hqv0A-0000J5-9Q
 for 36777 <at> debbugs.gnu.org; Fri, 26 Jul 2019 03:50:54 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59454)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1hqv03-0002mU-PF; Fri, 26 Jul 2019 03:50:47 -0400
Received: from [2001:660:6102:320:e120:2c8f:8909:cdfe] (port=57122 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1hqv03-0000Ac-90; Fri, 26 Jul 2019 03:50:47 -0400
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Carl Dong <contact@HIDDEN>
Subject: Re: bug#36777: Guix Inferiors: Curious incorrect derivation output bug
References: <TifHDa-L4paOnZQruSSv3YhpIdqMvwlk7pwnElq9azsMZwEdFv3-0usXgSQkV4nIOuKoJzv-BwIurwdecWYX-BTGUn2xZXAqQzefQp85W7M=@carldong.me>
Date: Fri, 26 Jul 2019 09:50:45 +0200
In-Reply-To: <TifHDa-L4paOnZQruSSv3YhpIdqMvwlk7pwnElq9azsMZwEdFv3-0usXgSQkV4nIOuKoJzv-BwIurwdecWYX-BTGUn2xZXAqQzefQp85W7M=@carldong.me>
 (Carl Dong's message of "Wed, 24 Jul 2019 01:09:10 +0000")
Message-ID: <875znps08a.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 36777
Cc: 36777 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hello Carl,

Carl Dong <contact@HIDDEN> skribis:

> I have my manifest.scm here:
> https://github.com/dongcarl/bitcoin/blob/2019-06-guix-channels-and-inferi=
ors/contrib/guix/manifest.scm,
> and it references the aforementioned Guix channel.

This one appears to work for me (I interrupted it before it was done
compiling all the toolchains, though.)

> What I expect to happen is that now when I change my default profile's Gu=
ix
> version by 'guix pull'ing, it won't affect the environment that's generat=
ed by
> the manifest.scm. I've tested this with differing versions of Guix as my =
default
> profile, and this seems to work with 7304d5623ab5cc35289cb1535cbd0d8a3769=
1fac
> and 7f1c69f5d32bee6b8b6b902a9ce445e04aa9d07d being my default profile. Ho=
wever,
> I tried an older version b6dc08393e6a8313b88ce422fc3c1e4e9c0efc6f, and go=
t the
> following error:

When I put b6dc08393e6a8313b88ce422fc3c1e4e9c0efc6f in .guix-channel and
use that as my channel, it also works fine (well, I commented out the
toolchains as well.)

> ```
> guix environment: error: derivation `/gnu/store/r641vpqc9rfjhljf7rzfzwmkm=
pa642ls-info-dir.drv' has incorrect output `/gnu/store/q9hkdidycz3wq28xxgjq=
47bzx5s39k52-info-dir', should be `/gnu/store/z5hh2nl0h58b9f6hdxfwm00gjyxfc=
c3n-info-dir'
> ```

That definitely looks like a bug.

Could you send the faulty info-dir.drv file?

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#36777; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 Jul 2019 01:09:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Jul 23 21:09:28 2019
Received: from localhost ([127.0.0.1]:35846 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1hq5ma-0002Ca-4S
	for submit <at> debbugs.gnu.org; Tue, 23 Jul 2019 21:09:28 -0400
Received: from lists.gnu.org ([209.51.188.17]:46456)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <contact@HIDDEN>) id 1hq5mX-0002C0-Vi
 for submit <at> debbugs.gnu.org; Tue, 23 Jul 2019 21:09:26 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:34573)
 by lists.gnu.org with esmtp (Exim 4.86_2)
 (envelope-from <contact@HIDDEN>) id 1hq5mW-0003qm-UO
 for bug-guix@HIDDEN; Tue, 23 Jul 2019 21:09:25 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.1 required=5.0 tests=BAYES_50,RCVD_IN_DNSWL_LOW
 autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <contact@HIDDEN>) id 1hq5mV-0004z7-NS
 for bug-guix@HIDDEN; Tue, 23 Jul 2019 21:09:24 -0400
Received: from mail2.protonmail.ch ([185.70.40.22]:38405)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <contact@HIDDEN>) id 1hq5mV-0004pd-Bp
 for bug-guix@HIDDEN; Tue, 23 Jul 2019 21:09:23 -0400
Date: Wed, 24 Jul 2019 01:09:10 +0000
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=carldong.me;
 s=protonmail; t=1563930552;
 bh=1+Y7bq2lKEEAT7c9dGyl51CHzgJqUhfYlwK0a8RRI0M=;
 h=Date:To:From:Reply-To:Subject:Feedback-ID:From;
 b=jaDXPWhD1vJwKe5Xtu1A0FwZOd8iXh2I3bLQ5f4tiAE80fRpflplBnr3ku90LZDib
 dmrk+8TaYZQ9O+sWLLUPcKErIUYSb6ezfhbDPFfjnfypykbL+FaCQ111CzKBVHUK+E
 qTdUUveBTeH6ktyNiS8qwEnhjuZQVxWgqoZ2H+VE=
To: "bug-guix@HIDDEN" <bug-guix@HIDDEN>
From: Carl Dong <contact@HIDDEN>
Subject: Guix Inferiors: Curious incorrect derivation output bug
Message-ID: <TifHDa-L4paOnZQruSSv3YhpIdqMvwlk7pwnElq9azsMZwEdFv3-0usXgSQkV4nIOuKoJzv-BwIurwdecWYX-BTGUn2xZXAqQzefQp85W7M=@carldong.me>
Feedback-ID: a8j8tDUaJ4AYuDVBywMTwsJebN4w8TVXadJLsJb8td3t3dZi9RdXFlPaQvoFKnI9KgXySsPXcRkajVyY0cGTcA==:Ext:ProtonMail
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Received-From: 185.70.40.22
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Carl Dong <contact@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Hi all,

I've been working on improving the Guix build support on Bitcoin Core so th=
at
it'll be ready to use for official releases.

One of the things that I wanted to do was to use a combination of channels =
and
inferiors to have reproducible builds across time. I have most of it set up=
, but
am running into some trouble. Here are the details:

I have a Guix channel set up at https://github.com/dongcarl/bitcoin-guix, w=
here
I pin the Guix version to 6869b6635afd93872b8f0d9f2db0db4c0d765a86 in the
.guix-channel, and declare all my packages in packages.scm.

I have my manifest.scm here:
https://github.com/dongcarl/bitcoin/blob/2019-06-guix-channels-and-inferior=
s/contrib/guix/manifest.scm,
and it references the aforementioned Guix channel.

What I expect to happen is that now when I change my default profile's Guix
version by 'guix pull'ing, it won't affect the environment that's generated=
 by
the manifest.scm. I've tested this with differing versions of Guix as my de=
fault
profile, and this seems to work with 7304d5623ab5cc35289cb1535cbd0d8a37691f=
ac
and 7f1c69f5d32bee6b8b6b902a9ce445e04aa9d07d being my default profile. Howe=
ver,
I tried an older version b6dc08393e6a8313b88ce422fc3c1e4e9c0efc6f, and got =
the
following error:

```
guix environment: error: derivation `/gnu/store/r641vpqc9rfjhljf7rzfzwmkmpa=
642ls-info-dir.drv' has incorrect output `/gnu/store/q9hkdidycz3wq28xxgjq47=
bzx5s39k52-info-dir', should be `/gnu/store/z5hh2nl0h58b9f6hdxfwm00gjyxfcc3=
n-info-dir'
```

I remember my previous attempts at integrating channels and inferiors into =
our
workflow yielded a similar result, so I would like to know if this is a bug=
, and
how I might go about fixing this so that I can feel comfortable using infer=
iors
for our builds.

Nevertheless, thank you all for your hard work. The fact that we have infer=
iors
at all is marvelous!

Cheers,
Carl Dong
contact@HIDDEN
"I fight for the users"




Acknowledgement sent to Carl Dong <contact@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#36777; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 16 Aug 2019 21:15:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.